﻿<?xml version="1.0" encoding="utf-8" ?> 
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:template match="emule">

<xsl:choose>
<xsl:when test="@connected != 0">
	<html>
	<head>
		<meta http-equiv="content-type" content="text/html; charset=utf-8" />
	</head>
	<body>
		<table border="1">
		<tr>
			<td>
				<xsl:apply-templates select="header"/>
			</td>
		</tr>
		<xsl:apply-templates select="welcome"/>
		<xsl:apply-templates select="servers"/>
		<xsl:apply-templates select="files"/>
		<xsl:apply-templates select="shared"/>
		<xsl:apply-templates select="logs"/>
		<xsl:apply-templates select="debug"/>
		</table>
		
		<xsl:choose>
		<xsl:when test="@debug != 0">
		<br/>
		<form method="post" action="/debug">
		<i>[Debug] Xml command:</i>
		<br/>
		<textarea name="debug_cmd" cols="80" rows="3"></textarea>
		<input type="hidden" name="test" value="1"/>
		<br/>
		<input type="submit" value="Submit"/>
		</form>
		</xsl:when>
		</xsl:choose>
	</body>
	</html>
</xsl:when>
<xsl:otherwise>
	Not connected
</xsl:otherwise>
</xsl:choose>

</xsl:template>

<xsl:template match="header">
	<table>
	<tr>
		<td colspan="10">
			eMule Plus version <xsl:value-of select="@version_text" />
		</td>
	</tr>
	<tr>
		<td>
			<a href="/servers">Servers</a>
		</td>
		<td>
			<a href="/files">Downloads</a>
		</td>
		<td>
			<a href="/search">Search</a>
		</td>
		<td>
			<a href="/shared">Shared Files</a>
		</td>
		<td>
			<a href="/stats">Statistics</a>
		</td>
		<td>
			<a href="/graphs">Graphs</a>
		</td>
		<td>
			<a href="/logs">Logs</a>
		</td>
	</tr>
	</table>
</xsl:template>

<xsl:template match="welcome">
	<tr>
		<td>
			Welcome to new ePlus WebInterface!
		</td>
	</tr>
</xsl:template>

<xsl:template match="logs">
	<tr>
		<td>
			<b>Logs</b><br/>
			<table>
			<xsl:for-each select="log">
				<xsl:sort order="descending" select="@time" />
				<tr>
					<td>
						<b><xsl:value-of select="@time_text" /></b>
					</td>
					<td>
						<xsl:value-of select="@text" />
					</td>
				</tr>
			</xsl:for-each>
			</table>
		</td>
	</tr>
</xsl:template>

<xsl:template match="shared">
	<tr>
		<td>
			<b>Shared files</b><br/>
			<table>
				<tr>
					<td><b>Filename</b></td>
					<td><b>Size</b></td>
					<td><b>Link</b></td>
				</tr>		
				<xsl:for-each select="file">
				<xsl:sort order="ascending" select="@name" />
				<tr>
					<td>
						<xsl:value-of select="@name" />
					</td>
					<td>
						<xsl:value-of select="@size" />
					</td>
					<td>
						<xsl:value-of select="@link" />
					</td>
				</tr>
				</xsl:for-each>
			</table>
		</td>
	</tr>
</xsl:template>

</xsl:stylesheet>
